/* rndzahl.c
 * gibt eine Zufallszahl aus 
 * erstellt: Wed Jan 19 21:54:44 MET 2000
 * Autoren : Mirko Belickin und Joachim Wagner
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "namen.h"
#include "service.h"


/* Hauptprogramm 
 *
 */

int main(int argc, char *argv[])
{
  FILE *out = stdout;
  FILE *temp;
  int hilfe = 0;        /* 1 = Hilfe fuer Benutzer anzeigen */   
  int fehler = 0;       /* 1 = Programm falsch aufgerufen */
  int schalter = 1;     /* 0 = es folgen keine Schalter ('--' gefunden) */
  double a, b;
  int i, j;
  char *s;
  service_randomseed seed;     
  
  while ((schalter) && (argc>1) && (*argv[1]=='-')) {/* Schalter bearbeiten */
    switch ((argv[1])[1]) {
      case 'h': hilfe = 1;
                break;
      case '-': schalter = 0;
                break;
      default:  fprintf(stderr,"Schalter %s unbekannt.\n", argv[1]);
                fehler = 1;
                break;
    }
    argv[1] = argv[0];
    argv++; 
    argc--;
  }
  
  if ((argc>5) || (argc<4)) fehler = 1;
  if ((hilfe) || (fehler)) {             /* Hilfetext anzeigen */
    fprintf(stderr,"\nBenutzung: "
                   "%s [Schalter] [--] a b k [Ausgabedatei]\n\n",
                   argv[0]);
    fprintf(stderr,"Schalter: -h     fuer diese Hilfe\n");
    fprintf(stderr," a = linke Grenze des Intervalls\n");
    fprintf(stderr," b = rechte Grenze des Intervalls\n");
    fprintf(stderr," k = Keim fuer Zufallszahlengenerator\n");
    fprintf(stderr,"\nMirko Belickin und Joachim Wagner - 19. Januar 2000\n");
    exit(fehler);
  }
  a = atof(argv[1]);
  b = atof(argv[2]);
  s = argv[3];
  if (argc>4) {
    if (!(temp=fopen(argv[4],"wb"))) {
      fprintf(stderr,"Oeffnen der Datei %s fehlgeschlagen.", argv[4]);
      exit(1);
    }
    out = temp;
  }
  
  /* Initialisiere Zufallszahlengenerator */

  service_initseed(&seed, 0, 0, 0);
  i = strlen(s);
  while (*s) {
    service_add2seed(&seed, *s);
    s++;
  }
  service_add2seed(&seed, i);

  /* Zufallszahl ausgeben */

  fprintf(out,"%lg\n", a + (b-a) * service_drand(&seed));
  
  if (out != stdout) fclose(out);               /* Dateien ggf. schliessen */
  return 0;
}
