#!/bin/sh
#
# Gibt eine Tabelle (':'-separiert) zu den gefundenen Nullstellen

# 
# sicherstellen, dass alles bereit
#
(cd source && make install)
test -d ergebnis || mkdir ergebnis

for FNR in 1 2 3 4              # Nr. der Beispielfunktion
do
  echo "FUNKTION $FNR"

  # 
  # Kopfzeile
  #
  for SCHRITTE in 5 80 1280 20480; do 
    echo -n ":"; echo -n $SCHRITTE; done
  echo

  # 
  # Schleife
  #
  for VERFAHREN in regulafa sekanten newton vereinfa muller; do 
    echo -n $VERFAHREN

    for SCHRITTE in 5 80 1280 20480; do
     
      KUERZEL=`echo $VERFAHREN | dd bs=1 count=1 2>/dev/null`

      NAME=ergebnis/${FNR}${KUERZEL}${SCHRITTE}
      test -f $NAME && rm $NAME

      #
      # naechste Tabellenzelle anlegen
      #
      echo -n ":"
      
      for I in 1 2 3 4 5 ; do   

        A=`rndzahl -- -10 10 ${I}A391A${FNR}${VERFAHREN}`
        B=`rndzahl -- $A 10  ${I}B446B${FNR}${VERFAHREN}`
        C=`rndzahl -- -10 10 ${I}C545C${FNR}${VERFAHREN}`

        case $VERFAHREN in
          regulafa) $VERFAHREN -s $SCHRITTE -- $A $B    $FNR >>$NAME ;;
          sekanten) $VERFAHREN -s $SCHRITTE -- $A $B    $FNR >>$NAME ;;
          newton)   $VERFAHREN -s $SCHRITTE -- $A       $FNR >>$NAME ;;
          vereinfa) $VERFAHREN -s $SCHRITTE -- $A       $FNR >>$NAME ;;
          muller)   $VERFAHREN -s $SCHRITTE -- $A $B $C $FNR >>$NAME ;;
          *) ZEILEN=$GRAD ;;
        esac

        #
        # in Tabelle eintragen
        #
        case $I in
          1) ;;
          *) echo -n "; " ;; 
        esac
        echo -n `tail -1 $NAME` 

      done
 
    done

    #
    # Tabellenzeile abschliessen
    #
    echo     
  done

  #
  # und die naechste Tabelle
  #
  echo     
done
